// GdalTheadIssueTest.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <string>

#include <gcore/gdal_priv.h>
#include <ogr/ogrsf_frmts/ogrsf_frmts.h>
#include <ogr_api.h>

void CPL_STDCALL GdalErrorHandler( CPLErr eErrClass, int nError,       const char * pszErrorMsg )
{
    switch(eErrClass)
    {
    case CE_None:
        break;
    case CE_Debug:
        break;
    case CE_Warning:
        printf("GDAL: %s", pszErrorMsg );
        break;
    case CE_Failure:
    case CE_Fatal:
        printf("GDAL: %s", pszErrorMsg );
        break;
    default:
        break;
    };

    printf("%s\n",pszErrorMsg);
};

DWORD WINAPI CheckThread(void *lpParameter)
{
	const std::string fileName("F:/real Sample Projects/Washington DC/vector/Building Footprints.shp");
	
	while(1)
	{
		

		OGRDataSource *poDS = (OGRDataSource *) OGROpenShared(fileName.c_str(),FALSE, NULL  );
		OGRLayer* poLayer = poDS->GetLayerByName( "Building Footprints" );
		OGRSpatialReference *poTargetReference = poLayer->GetSpatialRef();

		 OGRSpatialReference poSourceReference;
		poSourceReference.SetWellKnownGeogCS( "EPSG:4326" );
		OGRCoordinateTransformation* poTransform = 0, *poInvTransform = 0;


		poTransform = OGRCreateCoordinateTransformation( &poSourceReference, poTargetReference );
		poInvTransform = OGRCreateCoordinateTransformation( poTargetReference, &poSourceReference );


		if( poTransform )
		{
			OGRCoordinateTransformation::DestroyCT( poTransform );
		}

		if( poInvTransform )
		{
			OGRCoordinateTransformation::DestroyCT( poInvTransform );
		} 

		OGRReleaseDataSource( poDS );
	
	}
}

int _tmain(int argc, _TCHAR* argv[])
{
        GDALAllRegister();
        OGRRegisterAll();
        CPLSetErrorHandler( &GdalErrorHandler );
        CPLSetConfigOption("GDAL_DATA", "data/sdk/3rdpartygis/gdata");
        CPLSetConfigOption("PROJ_LIB",  "data/sdk/3rdpartygis/proj_lib");

		HANDLE pt[8] = {0};
		DWORD threadid;

		pt[0] = CreateThread(0, 0, CheckThread, 0, 0, &threadid);
		pt[0]  = CreateThread(0, 0,CheckThread, 0, 0, &threadid);
		//pt[0]  = CreateThread(0, 0, CheckThread, 0, 0, &threadid);
		//pt[0]  = CreateThread(0, 0, CheckThread, 0, 0, &threadid);
		//pt[0]  = CreateThread(0, 0, CheckThread, 0, 0, &threadid);

		Sleep(500000);
       // CPLSetConfigOption("CPL_TMPDIR",  temp_folder_.branch_path().string().c_str());
       // CPLSetConfigOption("TMPDIR",  temp_folder_.branch_path().string().c_str());
        //CPLSetConfigOption("TEMP",  temp_folder_.branch_path().string().c_str());
	
		//boost::filesystem::path gdal_wms_cache_dir = temp_folder_.branch_path()/="wms_cache/";
		//std::string mtemp = std::getenv ( "TEMP" );
		//mtemp.append("\\\wms_cache");
		
		// the GDAL group has not yet implimented these simple editions... 
		// its a gdal bug where if you don't do this the wms caches get 
		// randomly set..
		//CPLSetConfigOption("GDAL_DEFAULT_WMS_CACHE_PATH",  mtemp.c_str());
		//CPLSetConfigOption("GDAL_DEFAULT_WMS_CACHE_DEPTH", "10" );

	return 0;
}

